/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package coursfev2;

import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author krug
 */
public class ArithmeticDiv implements Arithmetic {
    private Arithmetic g, d;
    
    public ArithmeticDiv(Arithmetic ng, Arithmetic nd) {
        g = ng; d = nd;
    }
    
    public double calculateValue(HashMap variables) throws ArithmeticVariableUndefinedException {
        return g.calculateValue(variables) / d.calculateValue(variables);
    }

    public String prefixNotation() {
        return "( / "+ g.prefixNotation() + " " + d.prefixNotation() + " )";
    }

    public String infixNotation() {
        return "( "+ g.infixNotation() + " / " + d.infixNotation() + " )";
    }

    public String postfixNotation() {
        return "( "+ g.postfixNotation() + " " + d.postfixNotation() + " / )";
    }

    public boolean isSimplifiable() {
        return g.isSimplifiable() && d.isSimplifiable();
    }

    public Arithmetic simplify() {
        try {
            if (g.isSimplifiable() && d.isSimplifiable()) {
                return new ArithmeticValue(this.calculateValue(null));
            } else {
                return new ArithmeticDiv(g.simplify(), d.simplify());
            } 
        } catch (ArithmeticVariableUndefinedException ex) {
            ex.printStackTrace();
        }
        
        return null;
    }
}
