/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package coursfev2;

import coursfev.*;
import java.util.*;

/**
 *
 * @author krug
 */
public class ArithmeticMain {
    static Arithmetic parseSubExp(String s) {
        String toTest = s.trim();
        if(toTest.startsWith("(")) {
            toTest = toTest.substring(1); // skip
        }
        
        if(toTest.endsWith(")")) {
            toTest = toTest.substring(0, toTest.length() - 1);
        }
        
        int opPos = 0;
        int parenCount = 0;
        boolean found = false;
        while(!found && opPos < toTest.length()) {
            char c = toTest.charAt(opPos);
            if(c == '(')
                parenCount++;
            else if(c == ')')
                parenCount--;
            else {
                if(c == '+' || c == '-' || c == '*' || c == '/') {
                    if(parenCount == 0) {
                        found = true;
                        break;
                    }
                }
            }
            
            opPos++;
        }
        
        if (!found) {
            // num value
            try {
                return new ArithmeticValue(Double.parseDouble(toTest));
            } catch(Exception e) {
                return new ArithmeticVariable(toTest);
            }
        } else if (toTest.charAt(opPos) == '+') {
            String before = toTest.substring(0, opPos);
            String after = toTest.substring(opPos + 1, toTest.length());
            return new ArithmeticPlus(
                    ArithmeticMain.parseSubExp(before),
                    ArithmeticMain.parseSubExp(after));
        } else if (toTest.charAt(opPos) == '-') {
             String before = toTest.substring(0, opPos);
            String after = toTest.substring(opPos + 1, toTest.length());
           return new ArithmeticSub(
                    ArithmeticMain.parseSubExp(before),
                    ArithmeticMain.parseSubExp(after));
        } else if (toTest.charAt(opPos) == '*') {
                        String before = toTest.substring(0, opPos);
            String after = toTest.substring(opPos + 1, toTest.length());

            return new ArithmeticMult(
                    ArithmeticMain.parseSubExp(before),
                    ArithmeticMain.parseSubExp(after));
        } else if (toTest.charAt(opPos) == '/') {
                        String before = toTest.substring(0, opPos);
            String after = toTest.substring(opPos + 1, toTest.length());

            return new ArithmeticDiv(
                    ArithmeticMain.parseSubExp(before),
                    ArithmeticMain.parseSubExp(after));
        }

        return null;
    }
    
    public static void main(String[] args) {
        if(args.length == 0) {
            System.err.println("I need something to evaluate!");
            System.exit(-1);
        }
        
        Arithmetic exp = ArithmeticMain.parseSubExp(args[0]);
        HashMap variables = new HashMap();
        int i;
        for(i = 1 ; i < args.length ; i++) {
            // supposed to be var = val
            String arg = args[i];
            int equPos = arg.indexOf("=");
            if(equPos != -1) {
                String var = arg.substring(0, equPos).trim();
                double val = Double.parseDouble(arg.substring(equPos+1).trim());
                variables.put(var, new Double(val));
            }
        }
        
        try {
            System.out.println("Vars : " + variables + "\n" + exp.infixNotation() + " = " + exp.calculateValue(variables));
            Arithmetic simp = exp.simplify();
            System.out.println("Simplified : " + simp.infixNotation() + " = " + simp.calculateValue(variables));
        } catch (Exception e) {
            System.err.println("Error " + e.getMessage() + " in evaluation of " + exp.infixNotation() + " with variables " + variables);
        }

    }
}
